Index: TXM/trunk/org.txm.tests.rcp/src/org/txm/scripts/macro/tests/Test.java
===================================================================
--- TXM/trunk/org.txm.tests.rcp/src/org/txm/scripts/macro/tests/Test.java	(revision 0)
+++ TXM/trunk/org.txm.tests.rcp/src/org/txm/scripts/macro/tests/Test.java	(revision 3628)
@@ -0,0 +1,177 @@
+package org.txm.scripts.macro.tests;
+
+import java.io.File;
+import java.util.ArrayList;
+import java.util.List;
+
+import org.txm.groovy.core.GSERunner;
+
+import groovy.lang.Binding;
+
+public class Test {
+
+	String name;
+	File directory;
+	File create, export, test;
+	File create_ok, export_ok, test_ok;
+	File create_error, export_error, test_error;
+	File[] all = {create_ok, export_ok, test_ok, create_error, export_error, test_error};
+	
+	private Binding binding;
+
+	public Test(File scriptDir, String name) {
+		this.name = name;
+		//File scriptDir = new File(Toolbox.getTxmHomePath(), "scripts/groovy/user/org/txm/tests");
+		scriptDir.mkdirs();
+
+		this.directory = new File(scriptDir, name);
+		this.directory.mkdirs();
+		
+		create = new File(directory, "create.groovy");
+		export = new File(directory, "export.groovy");
+		test = new File(directory, "test.groovy");
+
+		create_ok = new File(directory, "create.ok");
+		export_ok = new File(directory, "export.ok");
+		test_ok = new File(directory, "test.ok");
+
+		create_error = new File(directory, "create.error");
+		export_error = new File(directory, "export.error");
+		test_error = new File(directory, "test.error");
+	}
+	
+	public void reset() {
+		create_ok.delete();
+		export_ok.delete();
+		test_ok.delete();
+
+		create_error.delete();
+		export_error.delete();
+		test_error.delete();
+	}
+	
+	public List<File> getLogs() {
+		ArrayList<File> logs = new ArrayList<File>();
+		for (File f : all) {
+			if (f.exists()) {
+				logs.add(f);
+			}
+		}
+	
+		return logs;
+	}
+
+	/**
+	 * 
+	 * @param start_step 0 starting step : all=create&export&test export=export&test test=step
+	 * @return
+	 */
+	public boolean run(int start_step) {
+		GSERunner gse = GSERunner.buildDefaultGSE();
+		System.out.println("Run "+name+" from "+start_step);
+		this.binding = new Binding();
+		try {
+			if (start_step <= 0) {
+				create_ok.delete();
+				create_error.delete();
+				Object ret_create = gse.run(create, binding);
+
+				if (ret_create != null && Boolean.FALSE != ret_create) {
+					binding.setProperty("results", ret_create);
+					create_ok.createNewFile();
+				} else {
+					create_error.createNewFile();
+					return false;
+				}
+			}
+
+			if (export.exists() && start_step <= 1) {
+				export_ok.delete();
+				export_error.delete();
+				Object ret_export = gse.run(export, binding);
+				if (ret_export != null && Boolean.FALSE != ret_export) {
+					export_ok.createNewFile();
+				} else {
+					create_error.createNewFile();
+					return false;
+				}
+
+				if (test.exists() && start_step <= 2) {
+					test_ok.delete();
+					test_error.delete();
+					Object ret_test = gse.run(test, binding);
+					if (ret_test != null && Boolean.FALSE != ret_test) {
+						test_ok.createNewFile();
+					} else {
+						test_error.createNewFile();
+						return false;
+					}
+				}
+			}
+		} catch (Exception e) {
+			e.printStackTrace();
+			return false;
+		}
+		
+		return true;
+	}
+
+	public boolean hasCreateStep() {
+		return create.exists();
+	}
+
+	public boolean hasExportStep() {
+		return export.exists();
+	}
+
+	public boolean hasTestStep() {
+		return test.exists();
+	}
+
+	public boolean isCreateStepOK() {
+		return create_ok.exists();
+	}
+
+	public boolean isExportStepOK() {
+		return export_ok.exists();
+	}
+
+	public boolean isTestStepOK() {
+		return test_ok.exists();
+	}
+
+	public File getCreateStepScript() {
+		return create;
+	}
+
+	public File getCreateStepLog() {
+		if (isCreateStepOK()) return create_ok;
+		return create_error;
+	}
+
+	public File getExportStepScript() {
+		return export;
+	}
+
+	public File getExportStepLog() {
+		if (isExportStepOK()) return export_ok;
+		return export_error;
+	}
+	
+	public File getTestStepScript() {
+		return test;
+	}
+
+	public File getTestStepLog() {
+		if (isTestStepOK()) return test_ok;
+		return test_error;
+	}
+
+	public String getName() {
+		return name;
+	}
+
+	public File getDirectory() {
+		return directory;
+	}
+}

Index: TXM/trunk/org.txm.tests.rcp/src/org/txm/scripts/macro/tests/TestBench.java
===================================================================
--- TXM/trunk/org.txm.tests.rcp/src/org/txm/scripts/macro/tests/TestBench.java	(revision 0)
+++ TXM/trunk/org.txm.tests.rcp/src/org/txm/scripts/macro/tests/TestBench.java	(revision 3628)
@@ -0,0 +1,57 @@
+package org.txm.scripts.macro.tests;
+
+import java.io.File;
+import java.io.IOException;
+import java.util.HashMap;
+
+import org.txm.utils.DeleteDir;
+
+public class TestBench {
+	HashMap<String, Test> tests = new HashMap<String, Test>();
+	
+	private File dir;
+	
+	public TestBench(File dir) {
+		this.dir = dir;
+		if (dir.exists()) {
+			for (File testDir : dir.listFiles()) {
+				if (new File(testDir, "create.groovy").exists()) {
+					String name = testDir.getName();
+					tests.put(name, new Test(dir, name));
+				}
+			}
+		}
+	}
+	
+	public HashMap<String, Test> getTests() {
+		return tests;
+	}
+	
+	public Test getTest(String name) {
+		return tests.get(name);
+	}
+	
+	public Test newTest(String name) {
+		
+		File testDir = new File(dir, name);
+		testDir.mkdir();
+		File create = new File(testDir, "create.groovy");
+		try {
+			create.createNewFile();
+		} catch (IOException e) {
+			e.printStackTrace();
+			return null;
+		}
+		
+		tests.put(name, new Test(dir, name));
+		return tests.get(name);
+	}
+	
+	public Test deleteTest(String name) {
+		
+		File testDir = new File(dir, name);
+		DeleteDir.deleteDirectory(testDir);
+		
+		return tests.remove(name);
+	}
+}

Index: TXM/trunk/org.txm.libs.itext/META-INF/MANIFEST.MF
===================================================================
--- TXM/trunk/org.txm.libs.itext/META-INF/MANIFEST.MF	(revision 3627)
+++ TXM/trunk/org.txm.libs.itext/META-INF/MANIFEST.MF	(revision 3628)
@@ -13,7 +13,7 @@
 Bundle-Version: 2.1.5
 Bundle-ClassPath: .,lib/iText-2.1.5.jar
 Bundle-ManifestVersion: 2
-Bundle-RequiredExecutionEnvironment: JavaSE-1.8
+Bundle-RequiredExecutionEnvironment: JavaSE-16
 Bundle-Vendor: itextpdf.com
 Automatic-Module-Name: org.txm.libs.itext
 

Index: TXM/trunk/org.txm.backtomedia.rcp/META-INF/MANIFEST.MF
===================================================================
--- TXM/trunk/org.txm.backtomedia.rcp/META-INF/MANIFEST.MF	(revision 3627)
+++ TXM/trunk/org.txm.backtomedia.rcp/META-INF/MANIFEST.MF	(revision 3628)
@@ -9,15 +9,16 @@
  vlcj-4.1.0/vlcj-natives-4.1.0.jar,
  opal-0.9.5.2.jar
 Require-Bundle: org.txm.core;bundle-version="0.7.0";visibility:=reexport,
- org.txm.rcp;bundle-version="0.8.0";visibility:=reexport,
+ org.txm.rcp;bundle-version="0.8.3";visibility:=reexport,
  org.eclipse.core.runtime;visibility:=reexport,
  org.eclipse.ui;visibility:=reexport,
  org.eclipse.core.expressions;bundle-version="3.4.500";visibility:=reexport,
  org.txm.concordance.core;bundle-version="1.0.0";visibility:=reexport,
  org.txm.concordance.rcp;bundle-version="1.0.0";visibility:=reexport,
- org.txm.edition.rcp;bundle-version="1.0.0";visibility:=reexport
+ org.txm.edition.rcp;bundle-version="1.0.0";visibility:=reexport,
+ org.txm.libs.javafx
 Bundle-ManifestVersion: 2
-Bundle-RequiredExecutionEnvironment: JavaSE-1.8
+Bundle-RequiredExecutionEnvironment: JavaSE-16
 Bundle-Vendor: %Bundle-Vendor
 Export-Package: org.txm.backtomedia.commands.function,
  org.txm.backtomedia.editors.input,

Index: TXM/trunk/org.txm.core/src/java/org/txm/scripts/importer/EncodeTEIQuotes.groovy
===================================================================
--- TXM/trunk/org.txm.core/src/java/org/txm/scripts/importer/EncodeTEIQuotes.groovy	(revision 3627)
+++ TXM/trunk/org.txm.core/src/java/org/txm/scripts/importer/EncodeTEIQuotes.groovy	(revision 3628)
@@ -27,6 +27,8 @@
 // $LastChangedBy: mdecorde $ 
 //
 
+import groovy.xml.XmlNodePrinter
+import groovy.xml.XmlParser
 import java.io.BufferedReader;
 import java.io.File;
 import java.io.FileInputStream;
@@ -407,7 +409,7 @@
 		this.quote= quote_value;
 		this.quote_type= quote_type;
 		println "process "+nodesToInspect.size()+" elements with containers "+containers
-		for(groovy.util.slurpersupport.Node root : nodesToInspect)//.body)
+		for(Node root : nodesToInspect)//.body)
 		{
 			println(" root : "+root.children().size())
 			processContainers(root, containers)
Index: TXM/trunk/org.txm.core/src/java/org/txm/core/results/TXMResult.java
===================================================================
--- TXM/trunk/org.txm.core/src/java/org/txm/core/results/TXMResult.java	(revision 3627)
+++ TXM/trunk/org.txm.core/src/java/org/txm/core/results/TXMResult.java	(revision 3628)
@@ -92,11 +92,6 @@
 	private static int next = 0;
 	
 	/**
-	 * Editor can use this to test if the result has been computed once.
-	 */
-	private boolean computedOnce = false;
-	
-	/**
 	 * The weight, essentially used for sorting purpose.
 	 */
 	protected int weight;
@@ -147,7 +142,7 @@
 	 * To keep track of the parameters used for the last computing and to determine if the result is dirty.
 	 * Also permits to optimize computing by testing if a specific parameter value has changed since last computing and skip or not some computing steps.
 	 */
-	protected ArrayList<HashMap<String, Object>> parametersHistory = new ArrayList<>();
+	protected ArrayList<HashMap<String, Object>> parametersHistory = null;
 	
 	/**
 	 * User persistable state.
@@ -506,6 +501,9 @@
 		// System.out.println("TXMResult.updateLastParameters() empty");
 		// }
 		
+		if (this.parametersHistory == null) { // 
+			this.parametersHistory = new ArrayList<HashMap<String,Object>>();
+		}
 		this.parametersHistory.add(lastParameters);
 		
 		// truncate the stack to the max count
@@ -546,6 +544,9 @@
 	 * @throws Exception
 	 */
 	protected void clearLastParameters(int parameterType) {
+		
+		if (parametersHistory == null) return; // nothing to do
+		
 		List<Field> fields = BeanParameters.getAllFields(this);
 		
 		for (Field f : fields) {
@@ -573,7 +574,7 @@
 		
 		
 		try {
-			if (this.getLastParametersFromHistory().isEmpty()) {
+			if (this.parametersHistory != null && !this.getLastParametersFromHistory().isEmpty()) {
 				this.parametersHistory.remove(this.parametersHistory.size() - 1);
 			}
 		}
@@ -591,6 +592,9 @@
 	 * @return
 	 */
 	public boolean hasParameterChanged(String key) {
+		
+		if (parametersHistory == null) return true;
+		
 		return this.hasParameterChanged(key, this.getLastParametersFromHistory());
 	}
 	
@@ -633,7 +637,7 @@
 	 * @param parameterType
 	 * @return
 	 */
-	public boolean hasParameterChanged(HashMap<String, Object> lastParameters, int parameterType) throws Exception {
+	public boolean hasParametersChanged(HashMap<String, Object> lastParameters, int parameterType) throws Exception {
 		
 		// result has never been computed
 		if (lastParameters == null) {
@@ -677,8 +681,10 @@
 	 * @return
 	 * @throws Exception
 	 */
-	public boolean hasParameterChanged() throws Exception {
-		return this.hasParameterChanged(this.getLastParametersFromHistory(), Parameter.COMPUTING);
+	public boolean hasParametersChanged() throws Exception {
+		if (parametersHistory == null) return true;
+		
+		return this.hasParametersChanged(this.getLastParametersFromHistory(), Parameter.COMPUTING);
 	}
 	
 	
@@ -845,7 +851,7 @@
 		// return this.hasParameterChanged();
 		// }
 		
-		if (this.hasParameterChanged()) {
+		if (this.hasParametersChanged()) {
 			this.dirty = true;
 		}
 	}
@@ -857,6 +863,7 @@
 	 */
 	public HashMap<String, Object> getLastParametersFromHistory() {
 		try {
+			if (parametersHistory == null) return null;
 			return this.parametersHistory.get(this.parametersHistory.size() - 1);
 		}
 		catch (Exception e) {
@@ -864,7 +871,25 @@
 		}
 	}
 	
+	/**
+	 * TODO seems to work but the TXMEditor.compute() method re-use the widgets values and the parametersHistory is appended with the 'new' parameters
+	 * 
+	 * @throws Exception
+	 */
+	public void revertParametersFromHistory() throws Exception {
+		ArrayList<HashMap<String, Object>> history = getParametersHistory();
+		if (history == null) return; // nothing to do
+		
+		if (history.size() < 2) return; // nothing to do
+		
+		history.remove(history.size() - 1);
+		
+		HashMap<String, Object> last = history.get(history.size() - 1);
+		
+		this.setParameters(last); // auto
+	}
 	
+	
 	/**
 	 * Dumps the parameters history stack to the specified StringBuffer.
 	 * 
@@ -1084,7 +1109,7 @@
 			this.saveParameter(TXMPreferences.PARENT_PARAMETERS_NODE_PATH, this.parent.getParametersNodePath());
 		}
 		
-		if (this.computedOnce) {
+		if (hasBeenComputedOnce()) {
 			this.lazyName = this.getSimpleName();
 		}
 		
@@ -1910,7 +1935,7 @@
 	 * 
 	 * @return a message indicating the start of computing
 	 */
-	// FIXME: SJ: this method must become abstract in TXM 0.8.2 and implemented by subclasses
+	// FIXME: SJ: this method must become abstract in TXM 0.8.3 and implemented by subclasses
 	public String getComputingStartMessage() {
 		return NLS.bind("Computing {0}...", this.getClass().getSimpleName());
 	}
@@ -1923,18 +1948,13 @@
 	 * 
 	 * @return a message indicating the computing is done
 	 */
-	// FIXME: SJ: this method must become abstract in TXM0.8.2 and implemented by subclasses
+	// FIXME: SJ: this method must become abstract in TXM-0.8.3+ and implemented by subclasses
 	public String getComputingDoneMessage() {
 		return TXMCoreMessages.common_done;
 	}
 	// public abstract String getComputingDoneMessage();
 	
-	
-	
-	
-	
-	
-	
+
 	/**
 	 * Gets the user name if exists otherwise, the simple name if not null, otherwise the lazy name.
 	 * 
@@ -2316,7 +2336,7 @@
 		// no changes to do
 		// FIXME: SJ: we need to do do some actions even if the object is locked, eg. updating parameters, saving parameters, etc.
 		// FIXME: MD: nope the parameters must not move and will be saved in the current state
-		if (this.computedOnce && this.locked) {
+		if (hasBeenComputedOnce() && this.locked) {
 			this.computing = false;
 			return true;
 		}
@@ -2354,7 +2374,7 @@
 			// this.updateDirtyFromHistory();
 			
 			// check if the result is dirty
-			if (!this.isDirty() && !hasParameterChanged()) {
+			if (!this.isDirty() && !hasParametersChanged()) {
 				Log.finest("--- TXMResult.compute(): " + this.getClass().getSimpleName() + ": result parameters have not changed since last computing, computing skipped.");
 				skipComputing = true;
 			}
@@ -2417,7 +2437,7 @@
 				
 				// store last used parameters
 				// this.updateLastParameters();
-				if (this.computedOnce// don't update the computing date if the object has been lazy loaded
+				if (hasBeenComputedOnce() // don't update the computing date if the object has been lazy loaded
 						|| this.lastComputingDate == null) { // set the update date if never computed once
 					this.lastComputingDate = Calendar.getInstance().getTime(); // update this internal parameter before saving parameters
 				}
@@ -2437,7 +2457,6 @@
 				}
 				
 				this.dirty = false; // the computing was successful, the result is no more dirty
-				this.computedOnce = true;
 				
 				if (this.altered) {
 					Log.info(NLS.bind("Warning {0} manual modifications have been lost.", this.getSimpleName()));
@@ -2547,7 +2566,6 @@
 			// set back to dirty
 			this.dirty = true;
 			this.computing = false;
-			this.computedOnce = false;
 			
 			// FIXME: SJ: old code, used when the monitor was stored in the TXMResult, need to check if we need a replacement for this
 			// this.monitorSetCanceled(true);
@@ -2773,7 +2791,7 @@
 	 * @return
 	 */
 	public boolean hasBeenComputedOnce() {
-		return computedOnce;
+		return parametersHistory != null;
 	}
 	
 	
Index: TXM/trunk/org.txm.core/src/java/org/txm/objects/BaseOldParameters.java
===================================================================
--- TXM/trunk/org.txm.core/src/java/org/txm/objects/BaseOldParameters.java	(revision 3627)
+++ TXM/trunk/org.txm.core/src/java/org/txm/objects/BaseOldParameters.java	(revision 3628)
@@ -20,11 +20,10 @@
 import org.txm.core.messages.TXMCoreMessages;
 import org.txm.utils.logger.Log;
 import org.txm.utils.xml.DomUtils;
-import org.w3c.dom.Document;
-import org.w3c.dom.Element;
-import org.w3c.dom.NodeList;
+import org.w3c.dom.*;
 import org.xml.sax.SAXException;
 
+
 public class BaseOldParameters implements IParameters {
 	
 	public static final DateFormat dateformat = new SimpleDateFormat("yyyy-MM-dd"); //$NON-NLS-1$
@@ -1141,5 +1140,6 @@
 		project.setXslt(this.getXsltElement(this.getCorpusElement()).getAttribute("xsl")); //$NON-NLS-1$
 		project.setAnnotate("true".equals(this.getCorpusElement().getAttribute("annotate"))); //$NON-NLS-1$ //$NON-NLS-2$ $NON-NLS-2$
 		project.setCleanAfterBuild(this.getCleanTEMPDirectories(this.getCorpusElement()));
+		project.setImportModuleName(scriptFile);
 	}
 }
Index: TXM/trunk/org.txm.core/src/java/org/txm/objects/Workspace.java
===================================================================
--- TXM/trunk/org.txm.core/src/java/org/txm/objects/Workspace.java	(revision 3627)
+++ TXM/trunk/org.txm.core/src/java/org/txm/objects/Workspace.java	(revision 3628)
@@ -52,13 +52,13 @@
  * The Class Workspace: manages the TXM corpora in the $TXMHOME/corpora directory
  */
 public class Workspace extends TXMResult {
-	
+
 	private static final String NAME = "name";
-	
+
 	IWorkspace rcpWorkspace;
-	
+
 	IWorkspaceRoot root;
-	
+
 	IProject corporaProject;
 	// /** The xmlfile. */
 	// File xmlDefinitionFile;
@@ -68,8 +68,8 @@
 	//
 	// /** The projs. */
 	// Element projs;
-	
-	
+
+
 	// /**
 	// * Creates the empty workspace.
 	// *
@@ -108,7 +108,7 @@
 	// }
 	// return true;
 	// }
-	
+
 	/**
 	 * Instantiates a new workspace.
 	 *
@@ -117,12 +117,12 @@
 	 */
 	private Workspace() throws CoreException {
 		super("ROOT");
-		
+
 		rcpWorkspace = ResourcesPlugin.getWorkspace();
 		rcpWorkspace.getRoot().refreshLocal(org.eclipse.core.resources.IResource.DEPTH_INFINITE, null);
 		root = rcpWorkspace.getRoot();
 		corporaProject = root.getProject("corpora");
-		
+
 		if (!corporaProject.exists()) {
 			try {
 				corporaProject.create(null);
@@ -132,17 +132,17 @@
 				e.printStackTrace();
 			}
 		}
-		
+
 		this.setUserName(corporaProject.getName()); // corpora
 		// this.setPath("/"+pName);
 		// this.xmlDefinitionFile = xmlfile;
 	}
-	
+
 	@Override
 	public boolean isInternalPersistable() {
 		return true;
 	}
-	
+
 	public static Workspace getInstance() {
 		if (Toolbox.workspace == null) {
 			try {
@@ -153,10 +153,10 @@
 				return null;
 			}
 		}
-		
+
 		return Toolbox.workspace;
 	}
-	
+
 	/**
 	 * Gets the projects.
 	 *
@@ -166,7 +166,7 @@
 	public List<Project> getProjects() {
 		return getChildren(Project.class);
 	}
-	
+
 	/**
 	 * Gets the project.
 	 *
@@ -181,33 +181,58 @@
 		}
 		return null;
 	}
-	
+
 	@Override
 	public String getSimpleName() {
 		return getUserName();
 	}
-	
+
 	@Override
 	public String getDetails() {
 		return getUserName();
 	}
-	
+
 	@Override
 	public void clean() {
 		// TODO Auto-generated method stub
 	}
-	
+
 	@Override
 	@Deprecated
 	public boolean _toTxt(File arg0, String arg1, String arg2, String arg3) throws Exception {
 		return false;
 	}
-	
+
 	public File getLocation() {
 		return corporaProject.getLocation().toFile().getAbsoluteFile();
 	}
-	
+
 	/**
+	 * 
+	 * @param binCorpusDir the directory to scan
+	 * @return true if the directory contains the mandatory files of a TXM 0.8.0+ corpus
+	 */
+	public static boolean isCorpusBinarydirectoryValid(File binCorpusDir) {
+
+		// System.out.println(Messages.Project_5);
+		File HTMLs = new File(binCorpusDir, "HTML"); //$NON-NLS-1$
+		// File TXMs = new File(binCorpusDir, "txm"); //$NON-NLS-1$
+		File DATAs = new File(binCorpusDir, "data"); //$NON-NLS-1$
+		File REGISTRY = new File(binCorpusDir, "registry"); //$NON-NLS-1$
+		File PARAMS = new File(binCorpusDir, ".settings"); //$NON-NLS-1$
+		File PROJECT = new File(binCorpusDir, ".project"); //$NON-NLS-1$
+
+		return binCorpusDir.exists() 
+				&& HTMLs.exists() 
+				&& DATAs.exists()
+				&& DATAs.listFiles().length > 0
+				&& REGISTRY.exists() 
+				&& REGISTRY.listFiles().length > 0
+				&& PARAMS.exists() 
+				&& PROJECT.exists();// && correspfile.exists())
+	}
+
+	/**
 	 * Scan directory:
 	 * 1- check the binary corpus format
 	 * 2- register in the workspace
@@ -217,7 +242,7 @@
 	 * @throws Exception
 	 */
 	public Project scanDirectory(File binCorpusDir) throws Exception {
-		
+
 		// System.out.println(Messages.Project_5);
 		File HTMLs = new File(binCorpusDir, "HTML"); //$NON-NLS-1$
 		// File TXMs = new File(binCorpusDir, "txm"); //$NON-NLS-1$
@@ -226,11 +251,11 @@
 		File PARAMS = new File(binCorpusDir, ".settings"); //$NON-NLS-1$
 		File PROJECT = new File(binCorpusDir, ".project"); //$NON-NLS-1$
 		binCorpusDir = new File(this.getLocation(), binCorpusDir.getName()); // this is to ensure the project is in the workspace files
-		
+
 		if (binCorpusDir.exists() && HTMLs.exists() && DATAs.exists()
 				&& REGISTRY.exists() && PARAMS.exists() && PROJECT.exists())// && correspfile.exists())
 		{// minimal base data
-			
+
 			File[] maincorpusNames = DATAs.listFiles();
 			String maincorpusName = "";
 			if (maincorpusNames.length == 0) { // no CQP corpus
@@ -240,7 +265,7 @@
 			else {
 				maincorpusName = maincorpusNames[0].getName();
 			}
-			
+
 			Project p = getProject(binCorpusDir.getName());
 			if (p != null) {
 				p.delete(); // a project with the same name already exists
@@ -249,24 +274,24 @@
 			if (p != null) {
 				p.delete(); // a project with the same name already exists
 			}
-			
+
 			// System.out.println(parameters.toString());
-			
+
 			// load the project from the project .settings directory
 			IWorkspace rcpWorkspace = ResourcesPlugin.getWorkspace();
 			// rcpWorkspace.getRoot().refreshLocal(1, new LogMonitor());
-			
+
 			IProjectDescription description = rcpWorkspace.loadProjectDescription(new Path(binCorpusDir.getAbsolutePath() + "/.project"));
 			description.setLocation(new Path(binCorpusDir.getAbsolutePath()));
 			IProject rcpProject = rcpWorkspace.getRoot().getProject(description.getName());
-			
+
 			if (!rcpProject.exists()) {
 				rcpProject.create(description, new LogMonitor());
 			}
 			if (!rcpProject.isOpen()) {
 				rcpProject.open(new LogMonitor());
 			}
-			
+
 			Project b = Project.loadProjectFromProjectScope(rcpProject);
 			if (b != null) {
 				return b;
@@ -282,8 +307,30 @@
 		}
 		return null;
 	}
-	
+
 	/**
+	 * 
+	 * @param binCorpusDir the directory to scan
+	 * @return true if the directory contains the mandatory files of a TXM 0.7.X corpus
+	 */
+	public static boolean isCorpus079DirectoryValid(File binCorpusDir) {
+		// System.out.println(Messages.Project_5);
+		File HTMLs = new File(binCorpusDir, "HTML"); //$NON-NLS-1$
+		// File TXMs = new File(binCorpusDir, "txm"); //$NON-NLS-1$
+		File DATAs = new File(binCorpusDir, "data"); //$NON-NLS-1$
+		File REGISTRY = new File(binCorpusDir, "registry"); //$NON-NLS-1$
+		File PARAMS = new File(binCorpusDir, "import.xml"); //$NON-NLS-1$
+
+		return binCorpusDir.exists()
+				&& HTMLs.exists() 
+				&& DATAs.exists()
+				&& DATAs.listFiles().length > 0
+				&& REGISTRY.exists() 
+				&& REGISTRY.listFiles().length > 0
+				&& PARAMS.exists();// && correspfile.exists())
+	}
+
+	/**
 	 * Scan directory:
 	 * 1- check the binary corpus format
 	 * 2- register in the workspace
@@ -293,16 +340,15 @@
 	 * @throws Exception
 	 */
 	public Project scanDirectory079(File binCorpusDir) throws Exception {
-		
+
 		// System.out.println(Messages.Project_5);
 		File HTMLs = new File(binCorpusDir, "HTML"); //$NON-NLS-1$
 		// File TXMs = new File(binCorpusDir, "txm"); //$NON-NLS-1$
 		File DATAs = new File(binCorpusDir, "data"); //$NON-NLS-1$
 		File REGISTRY = new File(binCorpusDir, "registry"); //$NON-NLS-1$
 		File PARAMS = new File(binCorpusDir, "import.xml"); //$NON-NLS-1$
-		
-		if (HTMLs.exists() && DATAs.exists()
-				&& REGISTRY.exists() && PARAMS.exists())// && correspfile.exists())
+
+		if (isCorpus079DirectoryValid(binCorpusDir))// && correspfile.exists())
 		{// minimal base data
 			BaseOldParameters parameters = new BaseOldParameters(PARAMS);
 			if (!parameters.load()) {
@@ -310,7 +356,7 @@
 				Log.severe(NLS.bind(TXMCoreMessages.failedToLoadBaseParametersFromTheP0File, PARAMS));
 				return null;
 			}
-			
+
 			// if (parameters.version == null || parameters.version.length() == 0) {
 			// System.out.println(TXMCoreMessages.Project_14);
 			// return null;
@@ -319,11 +365,11 @@
 			// System.out.println(CURRENTCORPUSVERSION+" > "+parameters.version); //$NON-NLS-1$
 			// return null;
 			// }
-			
+
 			// System.out.println(parameters.toString());
-			
+
 			// Creates a new project that doesn't need to build
-			
+
 			// FIXME: SJ: old version where there is a bug if the name or path are not in same case
 			// Project project = new Project(this, parameters.name, false);
 			// FIXME: SJ: new version that fix the bug but whe may want to not modify the case of the name?
@@ -332,7 +378,7 @@
 			// IPath destination = new Path(project.getRCPProject().getParent().getLocation(), parameters.name);
 			// project.getRCPProject().move(destination, true, project);
 			// }
-			
+
 			project._load(parameters);
 			project.pCorpusVersion = "0.7.9 -> 0.8.0";
 			// b._compute();
@@ -343,7 +389,7 @@
 				File HTMLc = new File(HTMLs, corpusname);
 				File REGISTRYc = new File(REGISTRY, corpusname.toLowerCase());
 				File DATAc = new File(DATAs, corpusname);
-				
+
 				if (!(PARAMS.exists() && HTMLc.exists() && REGISTRYc.exists() && DATAc.exists())) {
 					System.out.println(NLS.bind(TXMCoreMessages.errorColonSkippingTheLoadingOfTheP0Corpus, corpusname));
 					System.out.println(NLS.bind(TXMCoreMessages.pARAMSColonP0, PARAMS));
@@ -353,7 +399,7 @@
 					continue;
 				}
 			}
-			
+
 			return project;
 		}
 		else {
@@ -362,63 +408,63 @@
 		}
 		return null;
 	}
-	
-	
+
+
 	@Override
 	public boolean saveParameters() throws Exception {
 		return true;
 	}
-	
+
 	@Override
 	public boolean loadParameters() throws Exception {
 		return true;
 	}
-	
+
 	@Override
 	public boolean setParameters(TXMParameters parameters) throws Exception {
 		return true;
 	}
-	
+
 	@Override
 	public String getName() {
 		return getUserName();
 	}
-	
+
 	@Override
 	public boolean canCompute() throws Exception {
 		return true;
 	}
-	
+
 	@Override
 	protected boolean _compute(TXMProgressMonitor monitor) throws Exception {
 		// TODO should ensure its files are up to date
 		return true;
 	}
-	
+
 	@Override
 	public String getResultType() {
 		return "Workspace";
 	}
-	
+
 	/**
 	 * Loads and recreates the existing projects.
 	 * 
 	 * @throws CoreException
 	 */
 	public void loadProjectsFromProjectScopes(IProgressMonitor monitor) throws CoreException {
-		
+
 		Log.fine("Toolbox.initialize(): reloading projects...");
-		
+
 		IWorkspace rcpWorkspace = ResourcesPlugin.getWorkspace();
 		rcpWorkspace.getRoot().refreshLocal(org.eclipse.core.resources.IResource.DEPTH_INFINITE, null);
 		IProject corporaDirectory = rcpWorkspace.getRoot().getProject("corpora");
-		
+
 		if (!corporaDirectory.exists()) {
 			Log.severe("Can't load corpora projects: 'corpora' not found in workspace.");
 			return;
 		}
 		IProject projects[] = rcpWorkspace.getRoot().getProjects();
-		
+
 		Log.fine("Toolbox.initialize(): " + projects.length + " project(s) found in workspace.");
 		if (monitor != null) monitor.setTaskName(NLS.bind(TXMCoreMessages.initializingCorpora, 0, projects.length));
 		int c = 0;
@@ -430,7 +476,7 @@
 				project.delete(true, null);
 				continue;
 			}
-			
+
 			// project.open(monitor);
 			// String[] natures = project.getDescription().getNatureIds();
 			// if (Arrays.binarySearch(natures, Project.TXMCORPUSNATURE) < 0) continue;
@@ -438,7 +484,7 @@
 				Project.loadProjectFromProjectScope(project); // !!!
 			}
 		}
-		
+
 		// force the initialization of CorpusBuilds
 		for (TXMResult r : this.getChildren(Project.class)) {
 			Project project = (Project) r;
Index: TXM/trunk/org.txm.core/src/java/org/txm/objects/Project.java
===================================================================
--- TXM/trunk/org.txm.core/src/java/org/txm/objects/Project.java	(revision 3627)
+++ TXM/trunk/org.txm.core/src/java/org/txm/objects/Project.java	(revision 3628)
@@ -857,7 +857,8 @@
 			}
 			binaryDir = newBinDirectory; // switch the binaryDirectory to work
 		}
-		if (binaryDir.exists() && exportzip.getParentFile().exists()) {
+		if (binaryDir.exists() 
+				&& exportzip.getParentFile().exists()) {
 			this.save();
 			
 			if ("0.7.9".equals(version)) {
Index: TXM/trunk/org.txm.core/src/java/org/txm/utils/NameSpaceXmlNodePrinter.java
===================================================================
--- TXM/trunk/org.txm.core/src/java/org/txm/utils/NameSpaceXmlNodePrinter.java	(revision 3627)
+++ TXM/trunk/org.txm.core/src/java/org/txm/utils/NameSpaceXmlNodePrinter.java	(revision 3628)
@@ -16,7 +16,6 @@
  */
 
 import groovy.util.*;
-import groovy.xml.QName;
 import org.codehaus.groovy.runtime.InvokerHelper;
 
 import java.io.OutputStreamWriter;
@@ -25,6 +24,8 @@
 import java.util.List;
 import java.util.Map;
 
+import javax.xml.namespace.QName;
+
 /**
  * Prints a <code>groovy.util.Node</code> (as used with <code>XmlParser</code>) including all children in XML format.
  * Typical usage:
@@ -367,7 +368,7 @@
             if (!namespaceAware) {
                 return qname.getLocalPart();
             }
-            return qname.getQualifiedName();
+            return qname.getNamespaceURI();
         } else if (object instanceof Node) {
             Object name = ((Node) object).name();
             return getName(name);
Index: TXM/trunk/org.txm.core/src/java/org/txm/importer/ValidateXml.java
===================================================================
--- TXM/trunk/org.txm.core/src/java/org/txm/importer/ValidateXml.java	(revision 3627)
+++ TXM/trunk/org.txm.core/src/java/org/txm/importer/ValidateXml.java	(revision 3628)
@@ -28,7 +28,7 @@
 package org.txm.importer;
 
 import groovy.util.Node;
-import groovy.util.XmlParser;
+import groovy.xml.XmlParser;
 
 import java.io.File;
 import java.io.IOException;
@@ -112,7 +112,7 @@
 	 */
 	public static String testAndGetError(String xmldata) {
 		try {
-			new XmlParser().parseText(xmldata);
+			Node doc = new XmlParser().parseText(xmldata);
 			return "";
 		}
 		catch (IOException | ParserConfigurationException e) {
